<template id="modalCarpeta">
    <div 
        class="modal fade" 
        id="crearModal" 
        tabindex="-1" 
        role="dialog" 
        aria-labelledby="exampleModalLabel" 
        aria-hidden="true"
        @blur="resetForm()"
    >
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">
                        Nueva Carpeta
                    </h5>
                    <button 
                        type="button" 
                        class="close" 
                        data-dismiss="modal" 
                        aria-label="Close"
                    >
                        <span aria-hidden="true" @click="resetForm()">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <b-card 
                       no-nody 
                       class="overflow-hidden" 
                    >
                        <b-row no-gutters>
                            <b-col md="12">
                                <b-card-body>
                                    <div class="row">
                                        <div class="col form-group">
                                            <ImputTextComponent
                                                v-model="carpetaForm.nombre"
                                                label="Nombre Carpeta"
                                                placeholder="Escriba el nombre para la carpeta"
                                                :error="errorsBack.nombre"
                                            />
                                        </div>
                                    </div>
                                </b-card-body>
                            </b-col>
                        </b-row>
                    </b-card>
                </div>
                <div class="modal-footer">
                    <button 
                        type="button" 
                        class="btn btn-primary" 
                        data-dismiss="modal"
                        @click="resetForm()"
                    >
                        Cancelar
                    </button>
                    <button 
                        type="submit" 
                        class="btn btn-primary"
                        @click="registrarCarpeta()"
                    >
                        Crear
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import ImputTextComponent from '../../components/inputTextComponent.vue';
import { isEmpty }        from './../../utils/isEmpty';

export default {

    components: {
        ImputTextComponent
    },

    data: () => {
        return {
            carpetaForm: {
                nombre: "",
                id_usuario: localStorage.getItem('idUsuario')
            },
            errorsBack: {
                nombre: ""
            }
        }
    },

    methods: {
        resetErrors() {

            Object
                .entries(this.errorsBack)
                .forEach(([key, value]) => this.errorsBack[key] = "");
        },

        resetForm() {
            this.carpetaForm.nombre = "";
            this.resetErrors();
        },

        async registrarCarpeta() {

            this.resetErrors();
            if (this.carpetaFormIsInvalid()) return;

            try {
                const response = await axios.post(`/api/carpetas`, this.carpetaForm);
                
                this.$utils.showSuccess(response.data['message']);
                this.carpetaForm.nombre = "";
                this.$emit('carpeta-registrada')

            } catch (error) {

                const errorRequest = JSON.parse(error.request.response);

                Object
                    .entries(errorRequest['errors'])
                    .forEach(([key, value]) => this.errorsBack[key] = value[0]);
            }
        },

        carpetaFormIsInvalid() {

            var errorCount = 0;
            this.resetErrors();

            if (isEmpty(this.carpetaForm.nombre)) {
                this.errorsBack.nombre = "Nombre es requerido";
                errorCount++; 
            }

            return errorCount > 0;
        }
    }
}
</script>
<style>

</style>